Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 3633)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3597 2018-12-04 08:40:18Z maronga
 ! Removed call to calculation of near air (10 cm) potential temperature (now in
 ! surface layer fluxes)
@@ -421,8 +424,11 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  diss, diss_p, dzu, e, e_p, nc, nc_p, nr, nr_p, prho, pt, pt_p, pt_init, &
-               q_init, q, qc, qc_p, ql, ql_c, ql_v, ql_vp, qr, qr_p, q_p,      &
-               ref_state, rho_ocean, s, s_p, sa_p, tend, u, u_p, v, vpt,       &
-               v_p, w, w_p
+        ONLY:  d, diss, diss_p, ddzu, dd2zu, ddzw, drho_air, drho_air_zw, dzu, &
+               dzw, e, e_p, kh, km, nc, nc_p, nr, nr_p, p, prho, pt, pt_p,     &
+               pt_init, ptdf_x, ptdf_y, q_init, q, qc, qc_p, ql, ql_c, ql_v,   &
+               ql_vp, qr, qr_p, q_p, rdf, rdf_sc, ref_state, rho_air,          &
+               rho_air_zw, rho_ocean, s, s_p, sa_p, te_m, tend, tpt_m, tu_m,   &
+               tv_m, tw_m, u, ug, u_init, u_p, u_stokes_zu, v, vg, v_init, vpt,&
+               v_p, v_stokes_zu, w, w_p, zu
 
     USE biometeorology_mod,                                                    &
@@ -479,5 +485,5 @@
                time_dopr_listing, time_dopts, time_dosp, time_dosp_av,         &
                time_dots, time_do_av, time_do_sla, time_disturb, time_dvrp,    &
-               time_run_control, time_since_reference_point,                   &
+               time_run_control, time_since_reference_point, tsc,              &
                turbulent_inflow, turbulent_outflow, urban_surface,             &
                use_initial_profile_as_reference,                               &
@@ -499,5 +505,6 @@
 
     USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, nzb, nzt
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt, &
+               nz, nzb_max, advc_flags_1, advc_flags_2, wall_flags_0
 
     USE indoor_model_mod,                                                      &
@@ -556,4 +563,7 @@
               salsa_boundary_conds, salsa_gas, salsa_gases_from_chem,          &
               skip_time_do_salsa                      
+    
+    USE salsa_util_mod,                                                        &
+           ONLY:  sums_salsa_ws_l      
 
     USE spectra_mod,                                                           &
@@ -562,5 +572,10 @@
 
     USE statistics,                                                            &
-        ONLY:  flow_statistics_called, hom, pr_palm, sums_ls_l
+        ONLY:  flow_statistics_called, hom, pr_palm, sums_ls_l,                &
+               rmask, statistic_regions, weight_substep, sums_l_l,             &
+               sums_us2_ws_l, sums_wsus_ws_l, sums_vs2_ws_l, sums_wsvs_ws_l,   &
+               sums_ws2_ws_l, sums_wspts_ws_l, sums_wsqs_ws_l, sums_wssas_ws_l,&
+               sums_wsqcs_ws_l, sums_wsqrs_ws_l, sums_wsncs_ws_l,              &
+               sums_wsnrs_ws_l, sums_wsss_ws_l
 
     USE surface_layer_fluxes_mod,                                              &
@@ -568,5 +583,6 @@
 
     USE surface_mod,                                                           &
-        ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
+        ONLY:  bc_h, surf_def_h, surf_lsm_h, surf_usm_h,                       &
+               enter_surface_arrays, exit_surface_arrays
 
     USE surface_output_mod,                                                    &
@@ -623,4 +639,86 @@
     REAL(wp) ::  time_since_reference_point_save  !< original value of
                                                   !< time_since_reference_point
+
+
+! Copy data from arrays_3d
+!$ACC DATA & 
+!$ACC COPY(d(nzb+1:nzt,nys:nyn,nxl:nxr)) &
+!$ACC COPY(e(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(u(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(v(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(w(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(kh(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(km(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(pt(nzb:nzt+1,nysg:nyng,nxlg:nxrg))
+
+!$ACC DATA &
+!$ACC COPY(e_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(u_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(v_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(w_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(pt_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(te_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(tu_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(tv_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(tw_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPY(tpt_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg))
+
+!$ACC DATA &
+!$ACC COPYIN(rho_air(nzb:nzt+1), drho_air(nzb:nzt+1)) &
+!$ACC COPYIN(rho_air_zw(nzb:nzt+1), drho_air_zw(nzb:nzt+1)) &
+!$ACC COPYIN(zu(nzb:nzt+1)) &
+!$ACC COPYIN(dzu(1:nzt+1), dzw(1:nzt+1)) &
+!$ACC COPYIN(ddzu(1:nzt+1), dd2zu(1:nzt)) &
+!$ACC COPYIN(ddzw(1:nzt+1)) &
+!$ACC COPYIN(rdf(nzb+1:nzt), rdf_sc(nzb+1:nzt)) &
+!$ACC COPYIN(ptdf_x(nxlg:nxrg), ptdf_y(nysg:nyng)) &
+!$ACC COPYIN(ref_state(0:nz+1)) &
+!$ACC COPYIN(u_init(0:nz+1), v_init(0:nz+1)) &
+!$ACC COPYIN(u_stokes_zu(nzb:nzt+1), v_stokes_zu(nzb:nzt+1)) &
+!$ACC COPYIN(pt_init(0:nz+1)) &
+!$ACC COPYIN(ug(0:nz+1), vg(0:nz+1))
+
+! Copy data from control_parameters
+!$ACC DATA &
+!$ACC COPYIN(tsc(1:5))
+
+! Copy data from indices
+!$ACC DATA &
+!$ACC COPYIN(advc_flags_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPYIN(advc_flags_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+!$ACC COPYIN(wall_flags_0(nzb:nzt+1,nysg:nyng,nxlg:nxrg))
+
+! Copy data from surface_mod
+!$ACC DATA &
+!$ACC COPYIN(bc_h(0:1)) &
+!$ACC COPYIN(bc_h(0)%i(1:bc_h(0)%ns)) &
+!$ACC COPYIN(bc_h(0)%j(1:bc_h(0)%ns)) &
+!$ACC COPYIN(bc_h(0)%k(1:bc_h(0)%ns)) &
+!$ACC COPYIN(bc_h(1)%i(1:bc_h(1)%ns)) &
+!$ACC COPYIN(bc_h(1)%j(1:bc_h(1)%ns)) &
+!$ACC COPYIN(bc_h(1)%k(1:bc_h(1)%ns))
+
+! Copy data from statistics
+!$ACC DATA &
+!$ACC COPYIN(hom(nzb+1:nzb_max,1,1:3,0)) &
+!$ACC COPYIN(rmask(nysg:nyng,nxlg:nxrg,0:statistic_regions)) &
+!$ACC COPYIN(weight_substep(1:intermediate_timestep_count_max)) &
+!$ACC COPY(sums_l_l(nzb:nzt+1,0:statistic_regions,0)) &
+!$ACC COPY(sums_us2_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_wsus_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_vs2_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_wsvs_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_ws2_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_wspts_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_wssas_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_wsqs_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_wsqcs_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_wsqrs_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_wsncs_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_wsnrs_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_wsss_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_salsa_ws_l(nzb:nzt+1,0))
 
 !
@@ -739,4 +837,8 @@
        ENDIF   
        
+#ifdef _OPENACC
+       CALL enter_surface_arrays
+#endif
+        
 !
 !--    Start of intermediate step loop
@@ -1252,4 +1354,29 @@
 
        ENDDO   ! Intermediate step loop
+
+!
+!--    Will be used at some point by flow_statistics.
+       !$ACC UPDATE HOST(e, u, v, w, pt) &
+       !$ACC HOST(kh(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+       !$ACC HOST(km(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
+       !$ACC HOST(sums_l_l(nzb:nzt+1,0:statistic_regions,0)) &
+       !$ACC HOST(sums_us2_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_wsus_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_vs2_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_wsvs_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_ws2_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_wspts_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_wssas_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_wsqs_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_wsqcs_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_wsqrs_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_wsncs_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_wsnrs_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_wsss_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_salsa_ws_l(nzb:nzt+1,0))
+#ifdef _OPENACC
+       CALL exit_surface_arrays
+#endif
+
 !
 !--    If required, consider chemical emissions
@@ -1655,4 +1782,12 @@
     ENDDO   ! time loop
 
+!$ACC END DATA
+!$ACC END DATA
+!$ACC END DATA
+!$ACC END DATA
+!$ACC END DATA
+!$ACC END DATA
+!$ACC END DATA
+
 !
 !-- Vertical nesting: Deallocate variables initialized for vertical nesting    
Index: palm/trunk/SOURCE/timestep.f90
===================================================================
--- palm/trunk/SOURCE/timestep.f90	(revision 3633)
+++ palm/trunk/SOURCE/timestep.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3311 2018-10-05 12:34:56Z raasch
 ! Stokes drift is regarded in timestep calculation
 ! 
@@ -204,4 +207,5 @@
     REAL(wp), DIMENSION(3)         ::  reduce_l    !< 
     REAL(wp), DIMENSION(nzb+1:nzt) ::  dxyz2_min   !<  
+    !$ACC DECLARE CREATE(dxyz2_min)
 
 
@@ -277,4 +281,8 @@
        dt_v_l = 999999.9_wp
        dt_w_l = 999999.9_wp
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+       !$ACC COPY(dt_u_l, dt_v_l, dt_w_l, u_stokes_zu, v_stokes_zu) &
+       !$ACC REDUCTION(MIN: dt_u_l, dt_v_l, dt_w_l) &
+       !$ACC PRESENT(u, v, w, dzu)
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -313,4 +321,5 @@
        dt_diff_l = 999999.0_wp
 
+       !$ACC PARALLEL LOOP PRESENT(dxyz2_min, dzw)
        DO  k = nzb+1, nzt
            dxyz2_min(k) = MIN( dx2, dy2, dzw(k)*dzw(k) ) * 0.125_wp
@@ -319,4 +328,7 @@
        !$OMP PARALLEL private(i,j,k) reduction(MIN: dt_diff_l)
        !$OMP DO
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+       !$ACC COPY(dt_diff_l) REDUCTION(MIN: dt_diff_l) &
+       !$ACC PRESENT(dxyz2_min, kh, km)
        DO  i = nxl, nxr
           DO  j = nys, nyn
Index: palm/trunk/SOURCE/timestep_scheme_steering.f90
===================================================================
--- palm/trunk/SOURCE/timestep_scheme_steering.f90	(revision 3633)
+++ palm/trunk/SOURCE/timestep_scheme_steering.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -90,4 +93,6 @@
        ENDIF
 
+       !$ACC UPDATE DEVICE(tsc(1:5))
+
     ELSEIF ( timestep_scheme == 'euler' )  THEN
 !
Index: palm/trunk/SOURCE/transpose.f90
===================================================================
--- palm/trunk/SOURCE/transpose.f90	(revision 3633)
+++ palm/trunk/SOURCE/transpose.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -119,4 +122,6 @@
     !$OMP  PARALLEL PRIVATE ( i, j, k )
     !$OMP  DO
+     !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+     !$ACC PRESENT(f_inv, f_in)
      DO  i = 0, nx
          DO  k = nzb_x, nzt_x
@@ -166,4 +171,5 @@
 
     REAL(wp), DIMENSION(nyn_x-nys_x+1,nzb_y:nzt_y,nxl_y:nxr_y,0:pdims(2)-1) ::  work !< 
+    !$ACC DECLARE CREATE(work)
 
 
@@ -174,8 +180,10 @@
 !--    Transpose array
        CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start', cpu_log_nowait )
+       !$ACC UPDATE HOST(f_inv)
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
        CALL MPI_ALLTOALL( f_inv(nys_x,nzb_x,0),  sendrecvcount_xy, MPI_REAL, &
                           work(1,nzb_y,nxl_y,0), sendrecvcount_xy, MPI_REAL, &
                           comm1dy, ierr )
+       !$ACC UPDATE DEVICE(work)
        CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
 
@@ -186,4 +194,6 @@
        DO  l = 0, pdims(2) - 1
           ys = 0 + l * ( nyn_x - nys_x + 1 )
+          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+          !$ACC PRESENT(f_out, work)
           DO  i = nxl_y, nxr_y
              DO  k = nzb_y, nzt_y
@@ -203,4 +213,6 @@
 !$OMP  PARALLEL PRIVATE ( i, j, k )
 !$OMP  DO
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+       !$ACC PRESENT(f_out, f_inv)
        DO  k = nzb_y, nzt_y
           DO  i = nxl_y, nxr_y
@@ -246,4 +258,6 @@
     !$OMP  PARALLEL PRIVATE ( i, j, k )
     !$OMP  DO
+     !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+     !$ACC PRESENT(f_out, f_inv)
      DO  k = 1, nz
          DO  i = nxl, nxr
@@ -293,4 +307,5 @@
 
     REAL(wp), DIMENSION(nys_x:nyn_x,nnx,nzb_x:nzt_x,0:pdims(1)-1) ::  work !< 
+    !$ACC DECLARE CREATE(work)
 
 
@@ -307,4 +322,6 @@
        DO  l = 0, pdims(1) - 1
           xs = 0 + l * nnx
+          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+          !$ACC PRESENT(work, f_in)
           DO  k = nzb_x, nzt_x
              DO  i = xs, xs + nnx - 1
@@ -320,8 +337,10 @@
 !--    Transpose array
        CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start', cpu_log_nowait )
+       !$ACC UPDATE HOST(work)
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
        CALL MPI_ALLTOALL( work(nys_x,1,nzb_x,0), sendrecvcount_zx, MPI_REAL, &
                           f_inv(nys,nxl,1),      sendrecvcount_zx, MPI_REAL, &
                           comm1dx, ierr )
+       !$ACC UPDATE DEVICE(f_inv)
        CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
 #endif
@@ -333,4 +352,6 @@
 !$OMP  PARALLEL PRIVATE ( i, j, k )
 !$OMP  DO
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+       !$ACC PRESENT(f_inv, f_in)
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -378,4 +399,6 @@
     !$OMP  PARALLEL PRIVATE ( i, j, k )
     !$OMP  DO
+     !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+     !$ACC PRESENT(f_out, f_inv)
      DO  i = 0, nx
          DO  k = nzb_x, nzt_x
@@ -425,4 +448,5 @@
 
     REAL(wp), DIMENSION(nyn_x-nys_x+1,nzb_y:nzt_y,nxl_y:nxr_y,0:pdims(2)-1) ::  work !< 
+    !$ACC DECLARE CREATE(work)
 
 
@@ -436,4 +460,6 @@
        DO  l = 0, pdims(2) - 1
           ys = 0 + l * ( nyn_x - nys_x + 1 )
+          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+          !$ACC PRESENT(work, f_in)
           DO  i = nxl_y, nxr_y
              DO  k = nzb_y, nzt_y
@@ -449,8 +475,10 @@
 !--    Transpose array
        CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start', cpu_log_nowait )
+       !$ACC UPDATE HOST(work)
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
        CALL MPI_ALLTOALL( work(1,nzb_y,nxl_y,0), sendrecvcount_xy, MPI_REAL, &
                           f_inv(nys_x,nzb_x,0),  sendrecvcount_xy, MPI_REAL, &
                           comm1dy, ierr )
+       !$ACC UPDATE DEVICE(f_inv)
        CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
 #endif
@@ -462,4 +490,6 @@
 !$OMP  PARALLEL PRIVATE ( i, j, k )
 !$OMP  DO
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+       !$ACC PRESENT(f_inv, f_in)
        DO  i = nxl_y, nxr_y
           DO  k = nzb_y, nzt_y
@@ -587,4 +617,6 @@
     !$OMP  PARALLEL PRIVATE ( i, j, k )
     !$OMP  DO
+     !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+     !$ACC PRESENT(f_inv, f_in)
      DO  j = 0, ny
          DO  k = nzb_y, nzt_y
@@ -634,4 +666,5 @@
 
     REAL(wp), DIMENSION(nxl_z:nxr_z,nzt_y-nzb_y+1,nys_z:nyn_z,0:pdims(1)-1) ::  work !< 
+    !$ACC DECLARE CREATE(work)
 
 
@@ -643,4 +676,6 @@
 !$OMP  PARALLEL PRIVATE ( i, j, k )
 !$OMP  DO
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+       !$ACC PRESENT(f_out, f_inv)
        DO  j = 0, ny
           DO  k = nzb_y, nzt_y
@@ -658,8 +693,10 @@
 !--    Transpose array
        CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start', cpu_log_nowait )
+       !$ACC UPDATE HOST(f_inv)
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
        CALL MPI_ALLTOALL( f_inv(nxl_y,nzb_y,0),  sendrecvcount_yz, MPI_REAL, &
                           work(nxl_z,1,nys_z,0), sendrecvcount_yz, MPI_REAL, &
                           comm1dx, ierr )
+       !$ACC UPDATE DEVICE(work)
        CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
 
@@ -670,4 +707,6 @@
        DO  l = 0, pdims(1) - 1
           zs = 1 + l * ( nzt_y - nzb_y + 1 )
+          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+          !$ACC PRESENT(f_out, work)
           DO  j = nys_z, nyn_z
              DO  k = zs, zs + nzt_y - nzb_y
@@ -714,4 +753,6 @@
     !$OMP  PARALLEL PRIVATE ( i, j, k )
     !$OMP  DO
+    !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+    !$ACC PRESENT(f_in, f_inv)
      DO  k = 1,nz
          DO  i = nxl, nxr
@@ -761,4 +802,5 @@
 
     REAL(wp), DIMENSION(nys_x:nyn_x,nnx,nzb_x:nzt_x,0:pdims(1)-1) ::  work !< 
+    !$ACC DECLARE CREATE(work)
 
 
@@ -770,4 +812,6 @@
 !$OMP  PARALLEL PRIVATE ( i, j, k )
 !$OMP  DO
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+       !$ACC PRESENT(f_out, f_inv)
        DO  k = 1, nz
           DO  i = nxl, nxr
@@ -785,8 +829,10 @@
 !--    Transpose array
        CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start', cpu_log_nowait )
+       !$ACC UPDATE HOST(f_inv)
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
        CALL MPI_ALLTOALL( f_inv(nys,nxl,1),      sendrecvcount_zx, MPI_REAL, &
                           work(nys_x,1,nzb_x,0), sendrecvcount_zx, MPI_REAL, &
                           comm1dx, ierr )
+       !$ACC UPDATE DEVICE(work)
        CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
 
@@ -797,4 +843,6 @@
        DO  l = 0, pdims(1) - 1
           xs = 0 + l * nnx
+          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+          !$ACC PRESENT(f_out, work)
           DO  k = nzb_x, nzt_x
              DO  i = xs, xs + nnx - 1
@@ -845,4 +893,6 @@
     !$OMP  PARALLEL PRIVATE ( i, j, k )
     !$OMP  DO
+    !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+    !$ACC PRESENT(f_out, f_inv)
      DO  k = nzb_y, nzt_y
          DO  j = 0, ny
@@ -892,4 +942,5 @@
 
     REAL(wp), DIMENSION(nxl_z:nxr_z,nzt_y-nzb_y+1,nys_z:nyn_z,0:pdims(1)-1) ::  work !<
+    !$ACC DECLARE CREATE(work)
 
 !
@@ -905,4 +956,6 @@
        DO  l = 0, pdims(1) - 1
           zs = 1 + l * ( nzt_y - nzb_y + 1 )
+          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+          !$ACC PRESENT(work, f_in)
           DO  j = nys_z, nyn_z
              DO  k = zs, zs + nzt_y - nzb_y
@@ -918,8 +971,10 @@
 !--    Transpose array
        CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start', cpu_log_nowait )
+       !$ACC UPDATE HOST(work)
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
        CALL MPI_ALLTOALL( work(nxl_z,1,nys_z,0), sendrecvcount_yz, MPI_REAL, &
                           f_inv(nxl_y,nzb_y,0),  sendrecvcount_yz, MPI_REAL, &
                           comm1dx, ierr )
+       !$ACC UPDATE DEVICE(f_inv)
        CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
 #endif
@@ -930,4 +985,6 @@
 !$OMP  PARALLEL PRIVATE ( i, j, k )
 !$OMP  DO
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+       !$ACC PRESENT(f_inv, f_in)
        DO  k = nzb_y, nzt_y
           DO  j = 0, ny
Index: palm/trunk/SOURCE/tridia_solver_mod.f90
===================================================================
--- palm/trunk/SOURCE/tridia_solver_mod.f90	(revision 3633)
+++ palm/trunk/SOURCE/tridia_solver_mod.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -150,5 +153,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu_pres, ddzw, rho_air_zw
+           ONLY:  ddzu_pres, ddzw, rho_air_zw, tri
 
        IMPLICIT NONE
@@ -169,4 +172,8 @@
        CALL maketri
        CALL split
+
+       !$ACC ENTER DATA &
+       !$ACC COPYIN(ddzuw(0:nz-1,1:3)) &
+       !$ACC COPYIN(tri(nxl_z:nxr_z,nys_z:nyn_z,0:nz-1,1:2))
 
     END SUBROUTINE tridia_init
@@ -290,8 +297,11 @@
 
           REAL(wp), DIMENSION(nxl_z:nxr_z,nys_z:nyn_z,0:nz-1)   ::  ar1 !< 
+          !$ACC DECLARE CREATE(ar1)
 
 !
 !--       Forward substitution
+          !$ACC PARALLEL PRESENT(ar, ar1, tri) PRIVATE(i,j,k)
           DO  k = 0, nz - 1
+             !$ACC LOOP COLLAPSE(2)
              DO  j = nys_z, nyn_z
                 DO  i = nxl_z, nxr_z
@@ -306,4 +316,5 @@
              ENDDO
           ENDDO
+          !$ACC END PARALLEL
 
 !
@@ -312,5 +323,7 @@
 !--       by zero appearing if the pressure bc is set to neumann at the top of
 !--       the model domain.
+          !$ACC PARALLEL PRESENT(ar, ar1, ddzuw, tri) PRIVATE(i,j,k)
           DO  k = nz-1, 0, -1
+             !$ACC LOOP COLLAPSE(2)
              DO  j = nys_z, nyn_z
                 DO  i = nxl_z, nxr_z
@@ -325,4 +338,5 @@
              ENDDO
           ENDDO
+          !$ACC END PARALLEL
 
 !
@@ -332,4 +346,5 @@
           IF ( ibc_p_b == 1  .AND.  ibc_p_t == 1 )  THEN
              IF ( nys_z == 0  .AND.  nxl_z == 0 )  THEN
+                !$ACC PARALLEL LOOP PRESENT(ar)
                 DO  k = 1, nz
                    ar(nxl_z,nys_z,k) = 0.0_wp
